'Network User' is now 'Normal User'
[citadel.git] / citadel / debian / citadel.init
index 3343b0f06b6bbd352b791bb7127552f72fda5007..7fb213df9fc502c5c0587e28fe78c16ee251fd94 100644 (file)
@@ -1,36 +1,32 @@
-#! /bin/sh
+#!/bin/sh
 ### BEGIN INIT INFO
-# Provides:          skeleton
-# Required-Start:    $local_fs $remote_fs
-# Required-Stop:     $local_fs $remote_fs
+# Provides:          citadel
+# Required-Start:    $remote_fs $syslog
+# Required-Stop:     $remote_fs $syslog
 # Default-Start:     2 3 4 5
 # Default-Stop:      0 1 6
-# Short-Description: Example initscript
-# Description:       This file should be used to construct scripts to be
-#                    placed in /etc/init.d.
+# Short-Description: control citadel server start at boot time
+# Description:       control citadel server start at boot time
 ### END INIT INFO
 
-# Author: Foo Bar <foobar@baz.org>
-#
-# Please remove the "Author" lines above and replace them
-# with your own name if you copy and modify this script.
+# uncomment this to create coredumps as described in
+# http://www.citadel.org/doku.php/faq:mastering_your_os:gdb#how.do.i.make.my.system.produce.core-files
+# ulimit -c unlimited
 
-# Do NOT "set -e"
+# Author: Wilfried Goesgens <citadel@outgesourced.org>
 
-# PATH should only include /usr/* if it runs after the mountnfs.sh script
 RUNDIR=/var/run/citadel
 PATH=/sbin:/usr/sbin:/bin:/usr/bin
 DESC="Citadel Groupware "
 NAME=citserver
 DAEMON=/usr/sbin/$NAME
-DAEMON_ARGS=" -d -x3 -lmail -t/dev/null"
-PIDFILE=$RUNDIR/$NAME.pid
+PIDFILE=$RUNDIR/citadel.pid
+DAEMON_ARGS=" -d -lmail -t/dev/null"
 SCRIPTNAME=/etc/init.d/citadel
 SENDCOMMAND=/usr/sbin/sendcommand
 
-
 # Exit if the package is not installed
-[ -x "$DAEMON" ] || exit 0
+[ -x "$DAEMON" ] || { echo "$DAEMON not installed"; exit 1; }
 
 # Read configuration variable file if it is present
 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
@@ -54,9 +50,10 @@ fi
 #
 do_start()
 {
-        # for ubuntu: check our volatile dirs.
+        # check our volatile dirs.
         if test ! -d $RUNDIR; then
            mkdir -p $RUNDIR
+           chmod go+rx $RUNDIR
        fi
        # Return
        #   0 if daemon has been started
@@ -68,9 +65,6 @@ do_start()
        else
            return 2
        fi
-       # Add code here, if necessary, that waits for the process to be ready
-       # to handle requests from services started subsequently which depend
-       # on this one.  As a last resort, sleep for some time.
 }
 
 #
@@ -78,56 +72,43 @@ do_start()
 #
 do_stop()
 {
-       # Return
-       #   0 if daemon has been stopped
-       #   1 if daemon was already stopped
-       #   2 if daemon could not be stopped
-       #   other if a failure occurred
-        if $SENDCOMMAND "DOWN" >/dev/null 2>&1 ; then
-           rm -f $PIDFILE
+       if test -S $RUNDIR/citadel.socket; then 
+           sendcommand "DOWN" || :
+       fi
 
-           while test -S /var/run/citadel/citadel.socket; do 
+       PID=`cat $PIDFILE 2>/dev/null || :`
+       if [ ! -z $PID ]; then
+           rm -f $PIDFILE
+           count=0;
+           while test -S /var/run/citadel/citadel.socket -o -d /proc/$PID; do 
+               count=$(($count+1))
                sleep 1
                echo -n "."
+               if test "$count" = "10"; then
+                   kill $PID
+               fi
+               if test "$count" = "20"; then
+                   kill -9 $PID
+                   rm -rf /var/run/citadel/*
+               fi
            done
                return 0
-       else
-           rm -f $PIDFILE
-           return 2
        fi
 
-       #while test -d /proc/`cat $PIDFILE`; do
-       #    /usr/bin/printf  '.'
-       #    /bin/sleep 1
-       #done
-       #start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
-       #RETVAL="$?"
-       #[ "$RETVAL" = 2 ] && return 2
-       # Wait for children to finish too if this is a daemon that forks
-       # and if the daemon is only ever run from this initscript.
-       # If the above conditions are not satisfied then add some other code
-       # that waits for the process to drop all resources that could be
-       # needed by services started subsequently.  A last resort is to
-       # sleep for some time.
-       #start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
-       #[ "$?" = 2 ] && return 2
-       # Many daemons don't delete their pidfiles when they exit.
-       # rm -f $PIDFILE
+       return 0
 }
 
 #
 # Function that sends a SIGHUP to the daemon/service
 #
 do_reload() {
-       #
-       # If the daemon can reload its configuration without
-       # restarting (for example, when it is sent a SIGHUP),
-       # then implement that here.
-       #
-#      start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
-        do_stop
-        do_start
+       # Return
+       #   0 if daemon could not be restarted
+       #   1 if daemon has been restarted
+       #   other if a failure occurred
+        if $SENDCOMMAND "DOWN 1" 2>&1|grep '200 Restarting'>/dev/null ; then
+           return 1
+       fi
        return 0
 }
 
@@ -155,56 +136,43 @@ case "$1" in
        fi
        do_stop
        if test -n "$MODERN"; then
-           case "$?" in
-               0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
-               2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
-           esac
+               [ "$VERBOSE" != no ] && log_end_msg 0
        fi
        ;;
-  #reload|force-reload)
-       #
-       # If do_reload() is not implemented then leave this commented out
-       # and leave 'force-reload' as an alias for 'restart'.
-       #
-       #log_daemon_msg "Reloading $DESC" "$NAME"
-       #do_reload
-       #log_end_msg $?
-       #;;
-  restart|force-reload)
-       #
-       # If the "reload" option is implemented then remove the
-       # 'force-reload' alias
-       #
+  restart)
+       $0 stop
+       $0 start
+       ;;
+  force-reload)
        if test -n "$MODERN"; then
            log_daemon_msg "Restarting $DESC" "$NAME"
        else
            echo "Restarting $DESC" "$NAME"
        fi
 
-       do_stop
+       do_reload
 
        if test -n "$MODERN"; then
            case "$?" in
-               0|1)
-                   do_start
-                   case "$?" in
-                       0) log_end_msg 0 ;;
-                       1) log_end_msg 1 ;; # Old process is still running
-                       *) log_end_msg 1 ;; # Failed to start
-                   esac
+               0)
+                   log_end_msg 0
                    ;;
-               *)
+               1)
                # Failed to stop
                    log_end_msg 1
                    ;;
            esac
        fi
        ;;
+
+  status)
+       status_of_proc "$DAEMON" $NAME
+       ;;
+
   *)
-       #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
        exit 3
        ;;
 esac
 
-:
+exit 0